$(document).ready(function () {

  var sendData;

  $('#contact-form').validate({ // initialize the plugin
    rules: {
      email: {
        required: true,
        email: true
      },
      name: {
        required: true,
        minlength: 1
      }
    }
  });

//Code to develop a back-end system for this function was taken from the following website:
//The code was used in my google sheets, and is not present in any of the website code for this course.
//https://mashe.hawksey.info/2014/07/google-sheets-as-a-database-insert-with-apps-script-using-postget-methods-with-ajax-example/
//It provides a google script that can be used to allow a google sheet to accept data from an HTML form.

$("#contact-form").submit(function(event){ 

    if (sentData) { //removes requests if there are any in the que.
        sendData.abort();
    }

    var $contactForm = $(this);

    //finds elements within the HTML form in order to disable them.
    var $elements = $contactForm.find("input, select, button, textarea");

    // Serialize the data in the form
    var contactFormPickle = $contactForm.serialize();

    $elements.prop("disabled", true); //disable the form after the data has been serialized while the information is being submitted.

        //ajax request, sending the data to the google sheet.
        sendData = $.ajax({
            url: "https://script.google.com/macros/s/AKfycbzhy3N2tIg-ldd9xiwP3-eME2Zsn_bEroiqvX-8iZG7NvwluMF_/exec",
            type: "post",
            data: contactFormPickle
        });

    // When the request has been sent, the form will be cleared, and an alert will go off. 
    sendData.always(function () {
        alert("Your Contact Information has Been Submitted");
        $('#contact-form').trigger("reset");
        $elements.prop("disabled", false); //re-enable the form
    });

    event.preventDefault();
});

});